/* DCMAIN.PH */
/* Y.L. Noyelle, Supelec, France 1998 */

#ifndef DCMAIN_PH
#define DCMAIN_PH

#include "dc.th"

#define BackUp		ptrS--  /* to be used at most once (after a call to
					 NxtCh), because of circular buffer. */
#define FileClosed	(endSrcChunk == NULL)
#define NxtCh	/* gives back, in variable 'c', next source character;         \
		  manages trigraphs, line splicing, and buffer (re-)filling. */\
  for (;;) {								       \
    if (ptrS == endSrcChunk) ptrS = nxtChunkOfTxt();			       \
    c = *ptrS++;							       \
/*    if (c == '\?') {		*//* trigraph? *//*			       \
      if (ptrS == endSrcChunk) ptrS = nxtChunkOfTxt();			       \
      c = *ptrS++;							       \
      if (c == '\?') ptrS = trigraph(ptrS, &c);*//* *doIt* c not ds reg *//*   \
      else {BackUp; c = '\?';}						       \
      break;}*/								       \
    if (c!='\\' || !splice((char * /*~OddCast1*/)ptrS)) break; ptrS--;}	       \
							      /* splicing? */

/* Function profiles */
extern void endPrgF(register const char *ptrS);
extern void processInclude(
#ifdef VMS
	                   TstringNC
#else
	                   Tstring
#endif
		 		    , bool, bool, bool);
extern char *nxtChunkOfTxt(void);
extern void saveTokChar(char);
extern bool splice(char *);

/* Objects */
extern char *begSBuf;	/* beginning of source buffer (circular buffer) */
extern const char *endSrcChunk;
extern bool frstLineOfFile;
extern const char *nlPosP1;   /* 1 + position of last seen 'newline' char */
extern const char *srcPtr;    /* source pointer */
extern const char *savSrcPtr; /* stores 'real' source pointer when
				     getTokFromTxt() is used on another text. */

#endif  /* ifndef DCMAIN_PH */
/* End DCMAIN.PH */
